#pragma once

#ifdef _DEBUG
inline void OutputTrace(LPCWSTR str,...)
{
	wchar_t sz[256];
	va_list vs;
	va_start(vs, str);
	vswprintf(sz, 256, str, vs);
	OutputDebugString(sz);
}
#else
inline void OutputTrace(...)
{
}
#endif

#ifndef SAFE_DELETE
#define SAFE_DELETE(p) if(p){delete p;p=NULL;}
#endif
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) if(p){delete []p;p=NULL;}
#endif
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p) if(p){p->Release();p=NULL;}
#endif

typedef int GRET;

struct less_string_i : public binary_function<string, string, bool>
{
public:
	bool operator()(const string s1, const string s2) const {
		return _stricmp(s1.c_str(), s2.c_str())<0;
	}
};

struct less_wstring_i : public binary_function<wstring, wstring, bool>
{
public:
	bool operator()(const wstring s1, const wstring s2) const {
		return _wcsicmp(s1.c_str(), s2.c_str())<0;
	}
};

#define ARGB_RGB(a, rgb) ((a<<24) | (rgb & 0xFFFFFF))

#define GRET_OK 0
#define GRET_ERROR_NOD3D -0x0001
#define GRET_ERROR_NODSOUND -0x0002
#define GRET_ERROR_NODEVICE -0x0004
#define GRET_ERROR_FAIL -0x0008
#define GRET_ERROR_FILE -0x0010
#define GRET_ERROR_PARAM -0x0020
#define GRET_ERROR_OVERSTACK -0x0040
#define GRET_ERROR_WRONGFILE -0x0080
#define GRET_ERROR_MEMORY -0x0100

/*
rect_width(RECT rect), rect_height(RECT rect)

rect α̿ α̸ ȯѴ.
*/
inline int rect_width(RECT rect)
{
	return rect.right-rect.left;
}
inline int rect_height(RECT rect)
{
	return rect.bottom-rect.top;
}

inline bool isin(int p, int a, int b)
{
	return a<=p && p<b;
}

/*
POINT + POINT POINT - POINT ϵ
 
*/
inline POINT operator+(POINT& p1, POINT& p2)
{
	POINT ret;
	ret.x=p1.x+p2.x;
	ret.y=p1.y+p2.y;
	return ret;
}
inline POINT operator-(POINT& p1, POINT& p2)
{
	POINT ret;
	ret.x=p1.x-p2.x;
	ret.y=p1.x-p2.y;
	return ret;
}