#include "StdAfx.h"
#include "Comm.h"
#include "GGame.h"
#include "GSprites.h"

/*
GSprites 
*/
GSprites::GSprites()
{
}

/*
GSprites Ҹ
*/
GSprites::~GSprites()
{
	ReleaseTexture();
}


/*
GSprites::LoadTexture(DataInMem* file)

file ؽĸ о m_vptxt Ѵ.
*/
GRET GSprites::LoadTexture(DataInMem* file)
{
	if(!GGame::GetInstance()->GetDevice())return GRET_ERROR_NODEVICE;
	LPDIRECT3DTEXTURE9 ptxt;
	if(FAILED( D3DXCreateTextureFromFileInMemoryEx(GGame::GetInstance()->GetDevice(), 
		file->getsrc(), file->getsize(), 0, 0, 0, 0, D3DFMT_UNKNOWN, D3DPOOL_MANAGED,
		D3DX_DEFAULT, D3DX_DEFAULT, 0, NULL, NULL, &ptxt)) )
	{
		return GRET_ERROR_FAIL;
	}
	m_vptxt.push_back(ptxt);
	return GRET_OK;
}

/*
GSprites::ReleaseTexture()

  ؽĸ Ѵ.
*/
GRET GSprites::ReleaseTexture()
{
	for(size_t i=0;i<m_vptxt.size();i++)
	{
		SAFE_RELEASE(m_vptxt.back());
		m_vptxt.pop_back();
	}
	return GRET_OK;
}

/*
GSprites::AddSprites(DWORD itxt, int left, int top, int right, int bottom)

Ʈ ͸ m_vspr Ѵ.
*/
GRET GSprites::AddSprites(DWORD itxt, int left, int top, int right, int bottom)
{
	GSpriteDat d;
	d.itxt=itxt;
	d.rect.left=left;
	d.rect.top=top;
	d.rect.right=right;
	d.rect.bottom=bottom;
	m_vspr.push_back(d);
	return GRET_OK;
}

/*
GSprites::LoadSprites(DataInMem* file)

file Ʈ ͸ оͼ
m_vspr Ѵ.
*/
GRET GSprites::LoadSprites(DataInMem* file)
{
	DWORD num;
	if(file->read(&num, 4)<4)return GRET_ERROR_FILE;
	m_vspr.resize(num);
	file->read(&m_vspr[0], sizeof(GSpriteDat)*num);
	return 0;
}

/*
GSprites::DrawSprite(UINT index, int x, int y, D3DCOLOR color)

indexȣ Ʈ ȭ  (x,y) color ׸.
*/
GRET GSprites::DrawSprite(UINT index, int x, int y, D3DCOLOR color) const
{
	if(m_vspr.size()<=index)return GRET_ERROR_PARAM;
	D3DXMATRIX mat;
	GGame::GetInstance()->GetSprite()->SetTransform(D3DXMatrixIdentity(&mat));
	if(FAILED( GGame::GetInstance()->GetSprite()
		->Draw(m_vptxt[m_vspr[index].itxt], 
		&m_vspr[index].rect, NULL, 
		&D3DXVECTOR3((float)x, (float)y, 0), color) ))
	{
		return GRET_ERROR_FAIL;
	}
	return GRET_OK;
}


/*
GSprites::DrawSprite(UINT index, int x, int y, float sx, float sy, D3DCOLOR color)

indexȣ Ʈ ȭ  (x, y)
η sx, η sy ȮϿ color ׸.
*/
GRET GSprites::DrawSprite(UINT index, int x, int y, float sx, float sy, D3DCOLOR color) const
{
	if(m_vspr.size()<=index)return GRET_ERROR_PARAM;
	D3DXMATRIX mat, mat2;
	D3DXMatrixScaling(&mat, sx, sy, 0);
	mat*=*D3DXMatrixTranslation(&mat2, (float)x, (float)y, 0);
	GGame::GetInstance()->GetSprite()->SetTransform(&mat);
	if(FAILED( GGame::GetInstance()->GetSprite()
		->Draw(m_vptxt[m_vspr[index].itxt], 
		&m_vspr[index].rect, NULL, NULL, color) ))
	{
		return GRET_ERROR_FAIL;
	}
	return GRET_OK;
}

/*
GSprites::DrawSprite(UINT index, int x, int y, float rot, D3DCOLOR color)

indexȣ Ʈ ȭ  (x, y)
rotŭȸϿ color ׸.
rot  ̴.
*/
GRET GSprites::DrawSprite(UINT index, int x, int y, float rot, D3DCOLOR color) const
{
	if(m_vspr.size()<=index)return GRET_ERROR_PARAM;
	D3DXMATRIX mat, mat2;
	D3DXMatrixTranslation(&mat, rect_width(m_vspr[index].rect)*-.5f,
		rect_height(m_vspr[index].rect)*-.5f, 0);
	mat*=*D3DXMatrixRotationZ(&mat2, rot);
	mat*=*D3DXMatrixTranslation(&mat2, x+rect_width(m_vspr[index].rect)*.5f,
		y+rect_height(m_vspr[index].rect)*.5f, 0);
	GGame::GetInstance()->GetSprite()->SetTransform(&mat);
	if(FAILED( GGame::GetInstance()->GetSprite()
		->Draw(m_vptxt[m_vspr[index].itxt], 
		&m_vspr[index].rect, NULL, NULL, color) ))
	{
		return GRET_ERROR_FAIL;
	}
	return GRET_OK;
}

/*
GSprites::DrawSprite(UINT index, int x, int y, float sx, float sy, float rot, D3DCOLOR color)

indexȣ Ʈ ȭ  (x, y)
η sx, η sy Ȯϰ
rotŭȸϿ color ׸.
rot  ̴.
*/
GRET GSprites::DrawSprite(UINT index, int x, int y, float sx, float sy, float rot, D3DCOLOR color) const
{
	if(m_vspr.size()<=index)return GRET_ERROR_PARAM;
	D3DXMATRIX mat, mat2;
	D3DXMatrixTranslation(&mat, rect_width(m_vspr[index].rect)*-.5f,
		rect_height(m_vspr[index].rect)*-.5f, 0);
	mat*=*D3DXMatrixScaling(&mat2, sx, sy, 0);
	mat*=*D3DXMatrixRotationZ(&mat2, rot);
	mat*=*D3DXMatrixTranslation(&mat2, x+rect_width(m_vspr[index].rect)*.5f,
		y+rect_height(m_vspr[index].rect)*.5f, 0);
	GGame::GetInstance()->GetSprite()->SetTransform(&mat);
	if(FAILED( GGame::GetInstance()->GetSprite()
		->Draw(m_vptxt[m_vspr[index].itxt], 
		&m_vspr[index].rect, NULL, NULL, color) ))
	{
		return GRET_ERROR_FAIL;
	}
	return GRET_OK;
}

/*
GSprites::DrawSprite(UINT index, int x, int y, int sw, int sh, D3DCOLOR color)

indexȣ Ʈ ȭ  (x, y)
 sw,  sh ̷ ȮϿ
color ׸.
*/
GRET GSprites::DrawSprite(UINT index, int x, int y, int sw, int sh, D3DCOLOR color) const
{
	if(m_vspr.size()<=index)return GRET_ERROR_PARAM;
	return DrawSprite(index, x, y, (float)sw/rect_width(m_vspr[index].rect), 
		(float)sh/rect_height(m_vspr[index].rect), color);
}

/*
GSprites::DrawSprite(UINT index, int x, int y, int w, int h, int sx, int sy, D3DCOLOR color)

indexȣ Ʈ (sx, sy)
(w, h)ŭ ȭ  (x, y)
color ׸.
*/
GRET GSprites::DrawSprite(UINT index, int x, int y, int w, int h, int sx, int sy, D3DCOLOR color) const
{
	if(m_vspr.size()<=index)return GRET_ERROR_PARAM;
	D3DXMATRIX mat;
	GGame::GetInstance()->GetSprite()->SetTransform(D3DXMatrixIdentity(&mat));
	RECT r=m_vspr[index].rect;
	r.left+=sx;
	r.top+=sy;
	if(w>=0)r.right=r.left+w;
	if(h>=0)r.bottom=r.top+h;
	if(FAILED( GGame::GetInstance()->GetSprite()
		->Draw(m_vptxt[m_vspr[index].itxt], &r, NULL, 
		&D3DXVECTOR3((float)x, (float)y, 0), color) ))
	{
		return GRET_ERROR_FAIL;
	}
	return GRET_OK;
}

/*
GSprites::DrawSprite(UINT index, int x, int y, int sx, int sy, int w, int h, int sw, int sh D3DCOLOR color)

indexȣ Ʈ (sx, sy)
(w, h)ŭ ȭ  (x, y)
color ׸.
*/
GRET GSprites::DrawSprite(UINT index, int x, int y, int w, int h, 
						  int sx, int sy, int sw, int sh, D3DCOLOR color) const
{
	if(m_vspr.size()<=index)return GRET_ERROR_PARAM;
	D3DXMATRIX mat, mat2;
	D3DXMatrixScaling(&mat, (float)w/sw, (float)h/sh, 1.f);
	mat*=*D3DXMatrixTranslation(&mat2, (float)x, (float)y, 0.f);
	GGame::GetInstance()->GetSprite()->SetTransform(&mat);
	RECT r=m_vspr[index].rect;
	r.left+=sx;
	r.top+=sy;
	if(sw>=0)r.right=r.left+sw;
	if(sh>=0)r.bottom=r.top+sh;
	if(FAILED( GGame::GetInstance()->GetSprite()
		->Draw(m_vptxt[m_vspr[index].itxt], &r, NULL, 
		NULL, color) ))
	{
		return GRET_ERROR_FAIL;
	}
	return GRET_OK;
}
